<?php
function bb_footer_builder_content_box() {
	add_meta_box( 'bb_footer_builder_content', 'Custom Footer', 'bb_footer_builder_content_meta', BESTBUG_FB_FOOTER_POSTTYPE );
}

add_action( 'add_meta_boxes', 'bb_footer_builder_content_box' );

function bb_footer_builder_content_meta( $post ) {

	$bb_footer_max_width = get_post_meta( $post->ID, '_bb_footer_max_width', true );
	wp_nonce_field( 'bb_footer_verify', 'bb_footer_nonce' );

	?>
	<p>
		<label class="bbfb-metabox-label" for="_bb_footer_max_width">Footer max width</label>
		<input name="_bb_footer_max_width" id="_bb_footer_max_width"
		       value="<?php echo esc_html( $bb_footer_max_width ) ?>"/>
	</p>
	<?php
}

function bb_footer_builder_content_metabox_save( $post_id ) {
	if ( ! isset( $_POST['bb_footer_nonce'] ) ) {
		return;
	}
	$bb_footer_nonce = $_POST['bb_footer_nonce'];
	if ( ! wp_verify_nonce( $bb_footer_nonce, 'bb_footer_verify' ) ) {
		return;
	}

	if ( isset( $_POST['_bb_footer_max_width'] ) ) {
		$bb_footer_max_width = sanitize_text_field( $_POST['_bb_footer_max_width'] );
		update_post_meta( $post_id, '_bb_footer_max_width', $bb_footer_max_width );
	}
}

add_action( 'save_post', 'bb_footer_builder_content_metabox_save' );
