<?php
function bb_footer_builder_box() {
	add_meta_box( 'bb_footer_builder', 'Choose Footer', 'bb_footer_builder_meta', BBFBHelper::$post_types_only_key );
}

add_action( 'add_meta_boxes', 'bb_footer_builder_box' );

function bb_footer_builder_meta( $post ) {

	$bb_footer = get_post_meta( $post->ID, '_bb_footer', true );
	wp_nonce_field( 'bb_footer_verify', 'bb_footer_nonce' );

	$allFooters = array(
		'' => 'Default Footer',
	);
	$args       = array(
		'posts_per_page' => - 1,
		'post_type'      => 'bbfb_content',
		'orderby'        => 'title',
		'order'          => 'ASC',
	);
	$query      = new WP_Query( $args );

	if ( $query->post_count > 0 ) {
		foreach ( $query->posts as $key => $post ) {
			$allFooters[ $post->post_name ] = $post->post_title;
		}
	}
	?>

	<p>
		<select name="_bb_footer" id="_bb_footer">
			<?php foreach ( $allFooters as $footer_key => $footer_title ) { ?>
				<option
					value="<?php echo esc_html( $footer_key ) ?>" <?php echo ( $bb_footer == $footer_key ) ? 'selected="selected"' : ''; ?>><?php echo esc_html( $footer_title ) ?></option>
			<?php } ?>
		</select>
	</p>

	<?php
}

function bb_footer_builder_metabox_save( $post_id ) {
	if ( ! isset( $_POST['bb_footer_nonce'] ) ) {
		return;
	}
	$bb_footer_nonce = $_POST['bb_footer_nonce'];
	if ( ! wp_verify_nonce( $bb_footer_nonce, 'bb_footer_verify' ) ) {
		return;
	}

	if ( isset( $_POST['_bb_footer'] ) ) {
		$bb_footer = sanitize_text_field( $_POST['_bb_footer'] );
		update_post_meta( $post_id, '_bb_footer', $bb_footer );
	}
}

add_action( 'save_post', 'bb_footer_builder_metabox_save' );
