<?php
if ( ! defined( 'ABSPATH' ) ) {
	die;
}
?>
<div class="wrap bb_wrap bbfb_settings" id="bbfb-settings">
	<h2 class="bb-headtitle"><?php esc_html_e( 'Settings', 'bestbug' ) ?></h2>

	<form id="bb-form" method="post" action="">
		<div class="bb-form">
			<div class="bb-field-row">
				<div class="bb-label">
					<label><?php esc_html_e( 'Default footer', 'bestbug' ) ?></label>
				</div>
				<div class="bb-field">
					<select name="defaultFooter" id="defaultFooter">
						<?php foreach ( $this->allFooters as $footer_key => $footer_title ) { ?>
							<option
								value="<?php echo esc_html( $footer_key ) ?>" <?php echo ( $this->defaultFooter == $footer_key ) ? 'selected="selected"' : ''; ?>><?php echo esc_html( $footer_title ) ?></option>
						<?php } ?>
					</select>
				</div>
				<div class="bb-desc">
					<?php esc_html_e( "This Footer will show on all sites.", 'bestbug' ) ?>
				</div>
			</div>

			<div class="bb-field-row">
				<div class="bb-label">
					<label><?php esc_html_e( 'Post types', 'bestbug' ) ?></label>
				</div>
				<div class="bb-field">
					<?php foreach ( $this->all_posttypes as $key => $posttype ) { ?>
						<label>
							<input type="checkbox" name="post_types[<?php echo esc_attr( $key ) ?>]"
							       value="1" <?php if ( array_key_exists( $key, $this->post_types ) )
								echo 'checked="checked"' ?>><?php echo esc_html( $posttype ) ?></label>
					<?php } ?>
				</div>
				<div class="bb-desc">
					<?php esc_html_e( "Enable Custom Footer for pages, posts and custom post types.", 'bestbug' ) ?>
				</div>
			</div>

			<div class="bb-field-row">
				<div class="bb-label">
					<label><?php esc_html_e( 'Max width', 'bestbug' ) ?></label>
				</div>
				<div class="bb-field">
					<input type="text" name="maxWidth" value="<?php echo esc_html( $this->maxWidth ) ?>">
				</div>
				<div class="bb-desc">
					<?php esc_html_e( "Default is 1170px", 'bestbug' ) ?>
				</div>
			</div>

		</div>

		<input type="hidden" name="bbfb_update_general" value="1">
		<button type="submit" name="submit" class="button success">
			<span class="dashicons dashicons-admin-generic"></span>
			<?php esc_html_e( 'Save Changes', 'bestbug' ) ?>
		</button>
	</form>

</div>
