<?php

add_action( 'wp_footer', 'bb_footer_builder_filter' );

if ( ! function_exists( 'bb_footer_builder_filter' ) ) {
	function bb_footer_builder_filter() {

		$footer_name = BBFBHelper::$defaultFooter;

		if ( is_singular() && array_key_exists( get_post_type(), BBFBHelper::$post_types ) ) {
			$metadata = apply_filters( 'bbfb_get_footer_metadata', get_post_meta( get_the_ID(), BESTBUG_FB_METABOX_FOOTER, true ) );
			if ( $metadata ) {
				$footer_name = $metadata;
			}
		}

		if ( isset( $_REQUEST['bbfb_content'] ) && ! empty( $_REQUEST['bbfb_content'] ) ) {
			$footer_name = esc_attr( $_REQUEST['bbfb_content'] );
		}

		$footer_name = apply_filters( 'bbfb_get_footer_metadata_all', $footer_name );

		if ( ! $footer_name ) {
			return;
		}

		$footer = get_page_by_path( $footer_name, OBJECT, BESTBUG_FB_FOOTER_POSTTYPE );

		if ( ! $footer ) {
			return;
		}

		?>
		<div id="bb-footer-container-<?php echo esc_attr( $footer_name ) ?>" class="bb-footer-container">
			<div id="bb-footer-inside-<?php echo esc_attr( $footer_name ) ?>" class="bb-footer-inside">
				<?php echo do_shortcode( $footer->post_content ); ?>
			</div>
		</div>
		<?php
	}
}
if ( ! function_exists( 'bbfb_column_filter' ) ) {

	add_filter( 'vc_shortcodes_css_class', 'bbfb_column_filter', 10, 3 );

	function bbfb_column_filter( $class_string, $tag, $atts = null ) {
		if ( $tag != 'vc_column' ) {
			return $class_string;
		}

		if ( isset( $atts['width'] ) && $atts['width'] == '1/5' ) {

			$class_string = str_replace( "vc_col-sm-3", "vc_col-sm-1-per-5", $class_string );
		}

		return $class_string;
	}
}
