<?php
add_shortcode( 'bbfb_instagram', 'bbfb_instagram' );

function bbfb_instagram( $atts ) {

	$atts = shortcode_atts( array(
		'title'            => '',
		'username'         => '',
		'number_items'     => 6,
		'number_items_row' => 3,
		'color'            => '',
		'el_class'         => '',
	), $atts );

	extract( $atts );

	if ( empty( $username ) ) {
		return;
	}

	$square_media = 'on';
	$offset       = 0;

	$media_array = bbfb_get_instagram( $username, $number_items, $square_media, $offset );

	$html = '';

	if ( is_wp_error( $media_array ) ) {
		$html .= '<div class="bbfb-instagram-error">' . $media_array->get_error_message() . '</div>';
	} else {

		vc_icon_element_fonts_enqueue( 'font-awesome' );

		$html .= '<div class="bbfb-instagram">';
		if ( ! empty( $title ) ) :
			$html .= '<h5 class="bbfb-instagram-title bbfb-instagram-' . esc_attr( $color ) . '-title"> ' . esc_html( $title ) . ' </h5>';
		endif;

		$html .= '<div class="bbfb-instagram-row">';
		foreach ( $media_array as $item ) {
			$html .= '<div class="item">';
			$html .= '<a href="' . esc_url( $item['link'] ) . '" target="_blank">';
			//if ( 'on' == $show_likes_comments ) {
			$html .= '<div class="item-info">';
			$html .= '<span class="likes">' . $item['likes'] . '</span>';
			$html .= '<span class="comments">' . $item['comments'] . '</span>';
			$html .= '</div>';
			//}
			$html .= '<img src="' . esc_url( $item['thumbnail'] ) . '" alt="' . esc_html__( 'Instagram', 'tm-trio' ) . '" class="item-image"/>';
			$html .= '</a>';
			$html .= '</div>';
		}
		$html .= '</div>';

		$html .= '</div>';
	}

	return $html;
}

if ( defined( 'WPB_VC_VERSION' ) && function_exists( 'vc_add_param' ) ) {
	vc_map( array(
		'name'                      => esc_html__( 'Instagram', 'bestbug' ),
		'base'                      => 'bbfb_instagram',
		'category'                  => esc_html( sprintf( esc_html__( 'by %s', 'bestbug' ), BBFOOTER_DESIGNER_CATEGORY ) ),
		'icon'                      => '',
		'allowed_container_element' => 'vc_row',
		'params'                    => array(
			array(
				"type"        => "textfield",
				"class"       => "",
				"heading"     => esc_html__( 'Title', 'bestbug' ),
				"param_name"  => "title",
				"value"       => "",
				'admin_label' => true,
			),
			array(
				"type"        => "textfield",
				"class"       => "",
				"heading"     => esc_html__( 'Username', 'bestbug' ),
				"param_name"  => "username",
				"value"       => "",
				'admin_label' => true,
			),
			array(
				"type"        => "textfield",
				"class"       => "",
				"heading"     => esc_html__( 'Number of items', 'bestbug' ),
				"param_name"  => "number_items",
				"value"       => "",
				'admin_label' => true,
			),
			// array(
			//     'type'        => 'dropdown',
			//     'heading'     => esc_html__( 'Items per row', 'bestbug' ),
			//     'value'       => array(
			// 		'1' => 1,
			// 		'2' => 2,
			// 		'3' => 3,
			// 		'4' => 4,
			// 		'5' => 5,
			// 		'6' => 6,
			// 	),
			//     'param_name'  => 'number_items_row',
			// 	'admin_label' => true,
			// 	'save_always' => true,
			// ),
			array(
				'type'        => 'dropdown',
				'heading'     => esc_html__( 'Color', 'bestbug' ),
				'value'       => array(
					esc_html__( 'Dark', 'bestbug' )  => 'dark',
					esc_html__( 'Light', 'bestbug' ) => 'light',
				),
				'param_name'  => 'color',
				'admin_label' => true,
				'save_always' => true,
			),
			array(
				"type"       => "textfield",
				"class"      => "",
				"heading"    => esc_html__( 'Custom Class CSS', 'bestbug' ),
				"param_name" => "el_class",
			),
		),
	) );

}

function bbfb_get_instagram( $username, $slice, $square_media, $offset = 0 ) {

	$username = strtolower( $username );

	if ( false === ( $instagram = get_transient( 'instagram-media-new-' . sanitize_title_with_dashes( $username . '-' . $square_media ) ) ) ) {

		$remote = wp_remote_get( 'http://instagram.com/' . trim( $username ) );

		if ( is_wp_error( $remote ) ) {
			return new WP_Error( 'site_down', esc_html__( 'Unable to communicate with Instagram.', 'tm-trio' ) );
		}

		if ( 200 != wp_remote_retrieve_response_code( $remote ) ) {
			return new WP_Error( 'invalid_response', esc_html__( 'Instagram did not return a 200.', 'tm-trio' ) );
		}

		$shards      = explode( 'window._sharedData = ', $remote['body'] );
		$insta_json  = explode( ';</script>', $shards[1] );
		$insta_array = json_decode( $insta_json[0], true );

		if ( ! $insta_array ) {
			return new WP_Error( 'bad_json', esc_html__( 'Instagram has returned invalid data.', 'tm-trio' ) );
		}

		// old style
		if ( isset( $insta_array['entry_data']['UserProfile'][0]['userMedia'] ) ) {
			$media_arr = $insta_array['entry_data']['UserProfile'][0]['userMedia'];
			$type      = 'old';
			// new style
		} else if ( isset( $insta_array['entry_data']['ProfilePage'][0]['user']['media']['nodes'] ) ) {
			$media_arr = $insta_array['entry_data']['ProfilePage'][0]['user']['media']['nodes'];
			$type      = 'new';
		} else {
			return new WP_Error( 'bad_josn_2', esc_html__( 'Instagram has returned invalid data.', 'tm-trio' ) );
		}

		if ( ! is_array( $media_arr ) ) {
			return new WP_Error( 'bad_array', esc_html__( 'Instagram has returned invalid data.', 'tm-trio' ) );
		}

		switch ( $type ) {
			case 'old':
				$instagram = bbfb_get_media_old_style( $username, $media_arr );
				break;
			default:
				$instagram = bbfb_get_media_new_style( $media_arr, $square_media );
				break;
		}

		// do not set an empty transient - should help catch private or empty accounts
		if ( ! empty( $instagram ) ) {
			$instagram = base64_encode( serialize( $instagram ) );
			set_transient( 'instagram-media-new-' . sanitize_title_with_dashes( $username . '-' . $square_media ), $instagram, apply_filters( 'null_instagram_cache_time', HOUR_IN_SECONDS * 2 ) );
		}
	}

	if ( ! empty( $instagram ) ) {

		$instagram = unserialize( base64_decode( $instagram ) );

		return array_slice( $instagram, $offset, $slice );;

	} else {

		return new WP_Error( 'no_images', esc_html__( 'Instagram did not return any images.', 'tm-trio' ) );

	}
}

function bbfb_get_media_old_style( $username, $media_arr ) {

	$instagram = array();

	foreach ( $media_arr as $media ) {

		if ( $media['user']['username'] == $username ) {

			$media['link']                          = preg_replace( '/^http:/i', '', $media['link'] );
			$media['images']['thumbnail']           = preg_replace( '/^http:/i', '', $media['images']['thumbnail'] );
			$media['images']['standard_resolution'] = preg_replace( '/^http:/i', '', $media['images']['standard_resolution'] );
			$media['images']['low_resolution']      = preg_replace( '/^http:/i', '', $media['images']['low_resolution'] );

			$instagram[] = array(
				'link'      => $media['link'],
				'comments'  => bbfb_round_number( $media['comments']['count'] ),
				'likes'     => bbfb_round_number( $media['likes']['count'] ),
				'thumbnail' => $media['images']['thumbnail']['url'],
				'large'     => $media['images']['standard_resolution']['url'],
				'small'     => $media['images']['low_resolution']['url'],
			);
		}
	}

	return $instagram;
}

function bbfb_get_media_new_style( $media_arr, $square_media ) {

	$instagram = array();

	foreach ( $media_arr as $media ) {

		$img = ( 'on' == $square_media ) ? 'thumbnail_src' : 'display_src';

		$media[ $img ] = preg_replace( '/^http:/i', '', $media[ $img ] );

		$instagram[] = array(
			'link'      => '//instagram.com/p/' . $media['code'],
			'comments'  => bbfb_round_number( $media['comments']['count'] ),
			'likes'     => bbfb_round_number( $media['likes']['count'] ),
			'thumbnail' => $media[ $img ],
		);
	}

	return $instagram;
}

function bbfb_round_number( $number ) {
	if ( $number > 999 && $number <= 999999 ) {
		$result = floor( $number / 1000 ) . ' K';
	} elseif ( $number > 999999 ) {
		$result = floor( $number / 1000000 ) . ' M';
	} else {
		$result = $number;
	}

	return $result;
}
