<?php
add_shortcode( 'bbfb_menus', 'bbfb_menus' );

function bbfb_get_menu() {
	$menus = get_terms( 'nav_menu', array( 'hide_empty' => false ) );
	// Properly format the array.
	$items = array();
	foreach ( $menus as $menu ) {
		$items[ $menu->name ] = $menu->slug;
	}

	return $items;
}

function bbfb_menus( $atts ) {

	$atts = shortcode_atts( array(
		'title'      => '',
		'menu'       => '',
		'style'      => '',
		'color'      => '',
		'text_align' => '',
		'el_class'   => '',
	), $atts );

	extract( $atts );

	$nav_menu = wp_get_nav_menu_object( $menu ); // Get menu

	if ( ! $nav_menu ) {
		return;
	}

	$html = '<div class="bbfb-menu bbfb-menu-' . esc_attr( $style ) . ' bbfb-menu-' . esc_attr( $color ) . ' ' . esc_attr( $el_class ) . ' ' . esc_attr( $text_align ) . '">';
	if ( ! empty( $title ) ) :
		$html .= '<h5 class="bbfb-menu-title bbfb-menu-' . esc_attr( $color ) . '-title"> ' . esc_html( $title ) . ' </h5>';
	endif;
	$html .= wp_nav_menu( array( 'menu' => $nav_menu, 'echo' => false ) );
	$html .= '</div>';

	return $html;
}

if ( defined( 'WPB_VC_VERSION' ) && function_exists( 'vc_add_param' ) ) {
	vc_map( array(
		'name'                      => esc_html__( 'Menus', 'bestbug' ),
		'base'                      => 'bbfb_menus',
		'category'                  => esc_html( sprintf( esc_html__( 'by %s', 'bestbug' ), BBFOOTER_DESIGNER_CATEGORY ) ),
		'icon'                      => '',
		'allowed_container_element' => 'vc_row',
		'params'                    => array(
			array(
				"type"        => "textfield",
				"class"       => "",
				"heading"     => esc_html__( 'Title', 'bestbug' ),
				"param_name"  => "title",
				"value"       => "",
				'admin_label' => true,
			),
			array(
				'type'        => 'dropdown',
				'heading'     => esc_html__( 'Choose Menu', 'bestbug' ),
				'value'       => bbfb_get_menu(),
				'param_name'  => 'menu',
				'admin_label' => true,
				'save_always' => true,
			),
			array(
				'type'        => 'dropdown',
				'heading'     => esc_html__( 'Menu Style', 'bestbug' ),
				'value'       => array(
					'Default'                                => '',
					esc_html__( 'Inline Large', 'bestbug' )  => 'inline-large',
					esc_html__( 'Inline Normal', 'bestbug' ) => 'inline-normal',
					esc_html__( 'Inline Small', 'bestbug' )  => 'inline-small',
					esc_html__( 'List Normal', 'bestbug' )   => 'list-normal',
				),
				'param_name'  => 'style',
				'admin_label' => true,
				'save_always' => true,
			),
			array(
				'type'        => 'dropdown',
				'heading'     => esc_html__( 'Color', 'bestbug' ),
				'value'       => array(
					esc_html__( 'Dark', 'bestbug' )  => 'dark',
					esc_html__( 'Light', 'bestbug' ) => 'light',
				),
				'param_name'  => 'color',
				'admin_label' => true,
				'save_always' => true,
			),
			array(
				'type'        => 'dropdown',
				'heading'     => esc_html__( 'Text align', 'bestbug' ),
				'value'       => array(
					'Default'                         => '',
					esc_html__( 'Left', 'bestbug' )   => 'text-left',
					esc_html__( 'Center', 'bestbug' ) => 'text-center',
					esc_html__( 'Right', 'bestbug' )  => 'text-right',
				),
				'param_name'  => 'text_align',
				'admin_label' => true,
				'save_always' => true,
			),
			array(
				"type"       => "textfield",
				"class"      => "",
				"heading"    => esc_html__( 'Custom Class CSS', 'bestbug' ),
				"param_name" => "el_class",
			),
		),
	) );

}
